// ConsoleApplication1.cpp : Defines the entry point for the console application.
//
#include <conio.h>
#include "stdafx.h"
#include "EikonDesktopDataAPI.h"
#include "EikonDesktopEventListener.h"


CString GetPlatformStatusText(EEikonStatus a_eStatus)
{
	switch (a_eStatus)
	{
	case Connected:
		return _T("Connected");
	case Disconnected:
		return _T("Disconnected");
	case LocalMode:
		return _T("LocalMode");
	case Offline:
		return _T("Offline");
	}
	return _T("Unknown");
}


DWORD WINAPI listenerThread(LPVOID lpParameter)
{
	char & _ch = *((char*) lpParameter);
	while( true )
	{
		_ch = _getch();
		if (_ch == 'q') break;

	}
	return 0;
}

int _tmain(int argc, _TCHAR* argv[])
{
	char myChar = ' ';

	HRESULT l_hr = CoInitialize(0);

	CEikonDesktopDataAPI m_eikonDesktopAPI;
	EikonDesktopEventListener evenListener(&m_eikonDesktopAPI);
	l_hr = m_eikonDesktopAPI.CreateObject();
	if (l_hr != S_OK)
	{
		return -1;
	}
    EEikonDataAPIInitializeResult l_initStatus = m_eikonDesktopAPI.Initialize(&evenListener);
	if (l_initStatus == Succeed)
	{
		wprintf_s(L"\n\nConnecting...\n");
	}
	else
	{
		EEikonStatus l_status = m_eikonDesktopAPI.GetStatus();
		printf_s("\n\n%s\n",GetPlatformStatusText(l_status));
		exit(-1);
	}
	
	DWORD myThreadID;
	HANDLE myHandle = CreateThread(0, 0, listenerThread, &myChar, 0, &myThreadID);
	
	printf_s("\n\n*** press 'q' to terminate ***\n\n");

	MSG msg;
    while (GetMessage(&msg, NULL, 0, 0))
    {
	
        TranslateMessage(&msg);
        DispatchMessage(&msg);		
		
		if (myChar == 'q') break;
    }
	
	printf_s("\n\nTerminating...\n");
	return 0;
}

