#pragma once
#include "IEikonDesktopDataAPIEventListener.h"
#include "EikonDesktopDataAPI.h"
#include "AdxRtList.h"
#include "IAdxRtListEventListener.h"
#include <atlstr.h>
#include <vector>

class EikonDesktopEventListener : public IEikonDesktopDataAPIEventListener, public IAdxRtListEventListener
{
public:
	EikonDesktopEventListener(CEikonDesktopDataAPI* p);
	~EikonDesktopEventListener(void);

	void OnStatusChanged(EEikonStatus a_eStatus);

	void OnUpdate(BSTR a_itemName, VARIANT a_userTag, enum RT_ItemStatus a_itemStatus);
	void OnImage(RT_DataStatus a_dataStatus);
	void OnTime();
	void OnStatusChange(RT_ListStatus a_listStatus, RT_SourceStatus a_sourceStatus, RT_RunMode a_runMode);

private:
	CAdxRtList m_adxRtList;
	bool m_isAdxRtListAvailable;
	CEikonDesktopDataAPI* m_eikonDesktopAPI;

	CString GetPlatformStatusText(EEikonStatus a_eStatus);
	CString GetInstrumentStatusDescription(long a_itemStatus);
	CString GetFieldStatusDescription(long a_fieldStatus);
	void GetFieldInformation(CString a_itemName, 
									  std::vector<CString> &a_fieldNames, 
									  std::vector<CString> &a_fieldValues, 
									  std::vector<CString> &a_fieldStatuses );
};

